// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockComments is an autogenerated mock type for the Comments type
type MockComments struct {
	mock.Mock
}

// CreateComment provides a mock function with given fields: ctx, comment
func (_m *MockComments) CreateComment(ctx context.Context, comment *models.Comment) (*models.Comment, error) {
	ret := _m.Called(ctx, comment)

	if len(ret) == 0 {
		panic("no return value specified for CreateComment")
	}

	var r0 *models.Comment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Comment) (*models.Comment, error)); ok {
		return rf(ctx, comment)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Comment) *models.Comment); ok {
		r0 = rf(ctx, comment)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Comment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Comment) error); ok {
		r1 = rf(ctx, comment)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteComment provides a mock function with given fields: ctx, comment
func (_m *MockComments) DeleteComment(ctx context.Context, comment *models.Comment) error {
	ret := _m.Called(ctx, comment)

	if len(ret) == 0 {
		panic("no return value specified for DeleteComment")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Comment) error); ok {
		r0 = rf(ctx, comment)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetCommentByID provides a mock function with given fields: ctx, id
func (_m *MockComments) GetCommentByID(ctx context.Context, id string) (*models.Comment, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetCommentByID")
	}

	var r0 *models.Comment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Comment, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Comment); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Comment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCommentByPRN provides a mock function with given fields: ctx, prn
func (_m *MockComments) GetCommentByPRN(ctx context.Context, prn string) (*models.Comment, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetCommentByPRN")
	}

	var r0 *models.Comment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Comment, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Comment); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Comment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetComments provides a mock function with given fields: ctx, input
func (_m *MockComments) GetComments(ctx context.Context, input *GetCommentsInput) (*CommentsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetComments")
	}

	var r0 *CommentsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetCommentsInput) (*CommentsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetCommentsInput) *CommentsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*CommentsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetCommentsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateComment provides a mock function with given fields: ctx, comment
func (_m *MockComments) UpdateComment(ctx context.Context, comment *models.Comment) (*models.Comment, error) {
	ret := _m.Called(ctx, comment)

	if len(ret) == 0 {
		panic("no return value specified for UpdateComment")
	}

	var r0 *models.Comment
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Comment) (*models.Comment, error)); ok {
		return rf(ctx, comment)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Comment) *models.Comment); ok {
		r0 = rf(ctx, comment)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Comment)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Comment) error); ok {
		r1 = rf(ctx, comment)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockComments creates a new instance of MockComments. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockComments(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockComments {
	mock := &MockComments{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
